/* Tabela BASECALC: Base de Clculo */
/* Descrio: A trigger insere registros na tabela LOGOPERA a partir de alteraes na tabela BASECALC */
/* Objetivo: Gerar um log que vai registrar as alteraes na tabela Base de Clculo,
             utilizando a tabela Geral de Logs de Operaes */


IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
           WHERE O.NAME = 'LOG_FIS_BASECALC' AND
                 TYPE   = 'TR'               AND
	              U.UID  = O.UID              AND
	              U.NAME = USER)
DROP TRIGGER LOG_FIS_BASECALC
GO


CREATE TRIGGER LOG_FIS_BASECALC
ON BASECALC
FOR INSERT, UPDATE, DELETE
AS
   DECLARE  @V_USUARIO   VARCHAR(40);
   DECLARE  @V_TIPO      VARCHAR(1);
   DECLARE  @V_ITPESQ    VARCHAR(40);
   DECLARE  @V_DESC      VARCHAR(300);
   DECLARE  @V_DTOPER    DATETIME;


/*VARIVEIS DO CURSOR C_CURSOR*/

   DECLARE  @V_ID_COMANDO      VARCHAR(1);


   DECLARE  @V_CDIMPOSTO_OLD   VARCHAR(2);
   DECLARE  @V_NRSEQUBCALC_OLD VARCHAR(2);
   DECLARE  @V_CDENCARGO_OLD   VARCHAR(2);
   DECLARE  @V_CDIMPOBCALC_OLD VARCHAR(2);
   DECLARE  @V_IDTIPOBCALC_OLD VARCHAR(1);
   DECLARE  @V_CDCFOPIMPO_OLD  VARCHAR(11);
   DECLARE  @V_CDCSTIMPO_OLD   VARCHAR(2);
   DECLARE  @V_CDFISCIMPO_OLD  VARCHAR(1);

   DECLARE  @V_CDIMPOSTO_NEW   VARCHAR(2);
   DECLARE  @V_NRSEQUBCALC_NEW VARCHAR(2);
   DECLARE  @V_CDENCARGO_NEW   VARCHAR(2);
   DECLARE  @V_CDIMPOBCALC_NEW VARCHAR(2);
   DECLARE  @V_IDTIPOBCALC_NEW VARCHAR(1);
   DECLARE  @V_CDCFOPIMPO_NEW  VARCHAR(11);
   DECLARE  @V_CDCSTIMPO_NEW   VARCHAR(2);
   DECLARE  @V_CDFISCIMPO_NEW  VARCHAR(1);

BEGIN
   SET @V_TIPO = '0';
   SET @V_DESC = '';
   EXEC NMUSUARIO @V_USUARIO;
   SET @V_USUARIO = ISNULL(@V_USUARIO, '');

   DECLARE C_CURSOR CURSOR FOR
   SELECT 'D'
      IDCOMANDO,
      CDIMPOSTO,
      NRSEQUBCALC,
      CDENCARGO,
      CDIMPOBCALC,
      IDTIPOBCALC,
      CDCFOPIMPO,
      CDCSTIMPO,
      CDFISCIMPO,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL
   FROM
      DELETED
   WHERE
      CDIMPOSTO+NRSEQUBCALC NOT IN (SELECT CDIMPOSTO+NRSEQUBCALC FROM INSERTED)
   UNION ALL
   SELECT  'U'
      IDCOMANDO,
      DELETED.CDIMPOSTO,
      DELETED.NRSEQUBCALC,
      DELETED.CDENCARGO,
      DELETED.CDIMPOBCALC,
      DELETED.IDTIPOBCALC,
      DELETED.CDCFOPIMPO,
      DELETED.CDCSTIMPO,
      DELETED.CDFISCIMPO,
      INSERTED.CDIMPOSTO,
      INSERTED.NRSEQUBCALC,
      INSERTED.CDENCARGO,
      INSERTED.CDIMPOBCALC,
      INSERTED.IDTIPOBCALC,
      INSERTED.CDCFOPIMPO,
      INSERTED.CDCSTIMPO,
      INSERTED.CDFISCIMPO
   FROM
      INSERTED,
      DELETED
   WHERE
      INSERTED.CDIMPOSTO   = DELETED.CDIMPOSTO   AND
      INSERTED.NRSEQUBCALC = DELETED.NRSEQUBCALC
   UNION ALL

   SELECT 'I'
      IDCOMANDO,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      CDIMPOSTO,
      NRSEQUBCALC,
      CDENCARGO,
      CDIMPOBCALC,
      IDTIPOBCALC,
      CDCFOPIMPO,
      CDCSTIMPO,
      CDFISCIMPO
   FROM
      INSERTED
   WHERE
      CDIMPOSTO+NRSEQUBCALC NOT IN (SELECT CDIMPOSTO+NRSEQUBCALC FROM DELETED);

   OPEN C_CURSOR;
   FETCH NEXT FROM C_CURSOR INTO  @V_ID_COMANDO,
                                  @V_CDIMPOSTO_OLD,
                                  @V_NRSEQUBCALC_OLD,
                                  @V_CDENCARGO_OLD,
                                  @V_CDIMPOBCALC_OLD,
                                  @V_IDTIPOBCALC_OLD,
                                  @V_CDCFOPIMPO_OLD,
                                  @V_CDCSTIMPO_OLD,
                                  @V_CDFISCIMPO_OLD,

                                  @V_CDIMPOSTO_NEW,
                                  @V_NRSEQUBCALC_NEW,
                                  @V_CDENCARGO_NEW,
                                  @V_CDIMPOBCALC_NEW,
                                  @V_IDTIPOBCALC_NEW,
                                  @V_CDCFOPIMPO_NEW,
                                  @V_CDCSTIMPO_NEW,
                                  @V_CDFISCIMPO_NEW;

   WHILE (@@FETCH_STATUS = 0) BEGIN
      IF @V_ID_COMANDO = 'D' BEGIN
         IF @V_CDENCARGO_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'Enca=' + @V_CDENCARGO_OLD;
         END;

         IF @V_CDIMPOBCALC_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' Impo=' + @V_CDIMPOBCALC_OLD;
         END;

         IF @V_IDTIPOBCALC_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' TipoBCalc=' + @V_IDTIPOBCALC_OLD;
         END;

         IF @V_CDCFOPIMPO_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' CFOpImpo=' + @V_CDCFOPIMPO_OLD;
         END;

         IF @V_CDCSTIMPO_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' CSTImpo=' + @V_CDCSTIMPO_OLD;
         END;

         IF @V_CDFISCIMPO_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' CFImpo=' + @V_CDFISCIMPO_OLD;
         END;

         SET @V_TIPO = '3';
         SET @V_ITPESQ = @V_CDIMPOSTO_OLD + @V_NRSEQUBCALC_OLD;
      END
      ELSE
      IF @V_ID_COMANDO= 'U' /*UPDATING*/ BEGIN
         IF (@V_CDENCARGO_OLD   <> @V_CDENCARGO_NEW)   OR
            (@V_CDIMPOBCALC_OLD <> @V_CDIMPOBCALC_NEW) OR
            (@V_IDTIPOBCALC_OLD <> @V_IDTIPOBCALC_NEW) OR
            (@V_CDCFOPIMPO_OLD  <> @V_CDCFOPIMPO_NEW)  OR
            (@V_CDCSTIMPO_OLD   <> @V_CDCSTIMPO_NEW)   OR
            (@V_CDFISCIMPO_OLD  <> @V_CDFISCIMPO_NEW)  BEGIN

             SET @V_TIPO   = '2';
             SET @V_ITPESQ = @V_CDIMPOSTO_OLD + @V_NRSEQUBCALC_OLD;
          END;
      END
      ELSE BEGIN
         SET @V_TIPO   = '1';
         SET @V_ITPESQ = @V_CDIMPOSTO_NEW + @V_NRSEQUBCALC_NEW;
      END;
      IF @V_CDENCARGO_NEW IS NOT NULL BEGIN
         SET @V_DESC = @V_DESC + 'Enca=' + @V_CDENCARGO_NEW;
      END;
      IF @V_CDIMPOBCALC_NEW IS NOT NULL BEGIN
         SET @V_DESC = @V_DESC + ' Impo=' + @V_CDIMPOBCALC_NEW;
      END;
      IF @V_IDTIPOBCALC_NEW IS NOT NULL BEGIN
         SET @V_DESC = @V_DESC + ' TipoBCalc=' + @V_IDTIPOBCALC_NEW;
      END;
      IF @V_CDCFOPIMPO_NEW IS NOT NULL BEGIN
         SET @V_DESC = @V_DESC + ' CFOpImpo=' + @V_CDCFOPIMPO_NEW;
      END;
      IF @V_CDCSTIMPO_NEW IS NOT NULL BEGIN
         SET @V_DESC = @V_DESC + ' CSTImpo=' + @V_CDCSTIMPO_NEW;
      END;
      IF @V_CDFISCIMPO_NEW IS NOT NULL BEGIN
         SET @V_DESC = @V_DESC + ' CFImpo=' + @V_CDFISCIMPO_NEW;
      END;

      IF @V_TIPO <> '0' BEGIN
         EXEC NMUSUARIO @V_USUARIO;
         IF NOT @V_DESC IS NULL BEGIN
            IF NOT @V_USUARIO IS NULL BEGIN
               SET @V_DTOPER = GETDATE();

               INSERT INTO LOGOPERA
                  (NMTABELA,   DTOPERACAO, NMRESPOPER,
                   IDTIPOOPER, CDPESQITEM, DSOPERACAO)
               VALUES
                  ('BASECALC',  @V_DTOPER, @V_USUARIO,
                   @V_TIPO,      @V_ITPESQ, @V_DESC);
            END;
         END;
      END;
      FETCH NEXT FROM C_CURSOR INTO  @V_ID_COMANDO,
                                     @V_CDIMPOSTO_OLD,
                                     @V_NRSEQUBCALC_OLD,
                                     @V_CDENCARGO_OLD,
                                     @V_CDIMPOBCALC_OLD,
                                     @V_IDTIPOBCALC_OLD,
                                     @V_CDCFOPIMPO_OLD,
                                     @V_CDCSTIMPO_OLD,
                                     @V_CDFISCIMPO_OLD,

                                     @V_CDIMPOSTO_NEW,
                                     @V_NRSEQUBCALC_NEW,
                                     @V_CDENCARGO_NEW,
                                     @V_CDIMPOBCALC_NEW,
                                     @V_IDTIPOBCALC_NEW,
                                     @V_CDCFOPIMPO_NEW,
                                     @V_CDCSTIMPO_NEW,
                                     @V_CDFISCIMPO_NEW;

   END;
   CLOSE      C_CURSOR;
   DEALLOCATE C_CURSOR;
END;
GO


-- VERSAO --
EXEC ATUVEROBJ 'LOG_FIS_BASECALC','4.11.105';
GO

